Subject: bug#6998: 24.0.50; bidi: lines starting with neutral types have the wrong base direction?

From: Thamer Mahmoud <[email-masked]>
Date: Mon, 20 Sep 2010 17:45:00 +0300

Eli Zaretskii writes:
 > 
 > If you mean this example:
 > 
 > > * First
 > > [BLANK_LINE]
 > > ARABIC
 > > * Second
 > > 
 > > What I expect:
 > > 
 > > * First
 > > [BLANK_LINE]
 > >                                CIBARA
 > > * Second
 > > 
 > > What is shown in Emacs:
 > > 
 > > * First
 > > [BLANK_LINE]
 > >                                CIBARA
 > >                              Second *
 > 
 > Then it is also expected behavior: since there's no blank line between
 > "ARABIC" and "* Second", the latter is considered to belong to a
 > right-to-left paragraph, and rendered accordingly. 

Thanks for your comments, Eli.  I do mean the above example, as I can
see some inconsistent behavior when using org-mode.

It seems that Emacs _sometimes_ renders the above example in org-mode
as,

* First...
* Second

While in other invocations the same file is rendered as:

* First...
                             Second *

This behavior is not always reproducible. In X11, I have used the
following command to start 5 Emacs sessions with some having the first
rendering and others the second rendering:

i=5; while [ $i -gt 0 ] ; do ./emacs -Q --eval "(setq-default bidi-display-reordering t)" example2.org & let i=i-1; done;

I can also see a bug and a crash with the second rendering (and it got
me confused about how Emacs handles neutral types), so I wonder which
rendering should be considered as "correct"?

-- 
Thamer